# Подключение к Keil статического анализатора PVS-Studio

## Требования к установке
- установленный MDK-Arm v.5 (проверено на версии 5.38)
- установленный PVS-Studio (https://pvs-studio.ru/ru/pvs-studio/download/)
- установленный git (фактически из него используется только bash)

## Установка
- в каталоге с проектом .uvprojx создать папки PVS-STUDIO и scripts
- скопировать содержимое папки scripts
- исправить путь к git в переменной GIT_BASH_PATH внутри файлов: 
	check_project.bat
- исправить путь к PVS-Studio в переменной PVS_STUDIO_PATH внутри файлов: 
	CLMonitorDumpFilterLauncher_uVision.bat
	view_pvs_log.bat
- при необходимости отключения отдельных предупреждений - внести их список
  в файл ignore_warnings.pvsconfig
- в Keil отключить многопоточную компиляцию (Edit -> Configuration -> Other ->
  поставить галочку на Disable Parallel Build)
- в настройках проекта (Project -> Options for target -> User) прописать
  команды запуска скриптов:
  Before Compile C/C++ File 
  [+] Run 1: .\scripts\_before_compile.bat #X #E
  Before Build/Rebuild
  [+] Run 1: .\scripts\_before_build_dump.bat #X #P "myconfig_HVU" 
  где myconfig_HVU это установленное в проекте имя Target
  After Build/Rebuild
  [+] Run 1: .\scripts\_after_build.bat #X #P

## Использование
- в настройках проекта (Project -> Options for target -> User) установить галочки на все 3 скрипта
- выполнить полную пересборку проекта
- если новые файлы не добавляются то галочку с Before Compile можно снять
- готовый отчет можно посмотреть в текстовом файле PVS-STUDIO/<имя target>.plog.txt 
